diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
index b3ff065da..713a64d42 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
@@ -22,23 +22,23 @@ public class BiomeRainforest extends Biome
 	public WorldFeature getRandomWorldGenForTrees(Random random) {
 		if(random.nextInt(1000) == 0) {
 			int treeHeight = 30 + random.nextInt(30);
-			return new WorldFeatureSpoonerTreeRound(treeHeight, Blocks.LOG_OAK.id, 0, Blocks.LEAVES_OAK.id, 0);
+			return new WorldFeatureSpoonerTreeRound(treeHeight, Blocks.LOG_OAK.id(), 0, Blocks.LEAVES_OAK.id(), 0);
 		}
 		if(random.nextInt(10) == 0) {
 			return new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, true, false, true);
 		}
 		if(random.nextInt(3) == 0) {
 			if(random.nextInt(10) == 0) {
-				return new WorldFeatureTreeFancyRainforest(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK_MOSSY.id, 0);
+				return new WorldFeatureTreeFancyRainforest(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK_MOSSY.id(), 0);
 			}
-			return new WorldFeatureTreeFancyRainforest(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 0);
+			return new WorldFeatureTreeFancyRainforest(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 0);
 		}
 		if(random.nextInt(5) == 0) {
-			return new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id, Blocks.LOG_OAK.id);
+			return new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
 		}
 		if(random.nextInt(10) == 0) {
-			return new WorldFeatureTree(Blocks.LEAVES_CACAO.id, Blocks.LOG_OAK_MOSSY.id, 4);
+			return new WorldFeatureTree(Blocks.LEAVES_CACAO.id(), Blocks.LOG_OAK_MOSSY.id(), 4);
 		}
-		return new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 6);
+		return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 6);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java
index 2c31c5f4b..0a8b84f2e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java
@@ -35,10 +35,10 @@ public class BiomeRetro
     @Override
     public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        WorldFeature feature = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id, 4);
+        WorldFeature feature = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id(), 4);
         if (random.nextInt(10) == 0)
         {
-            feature = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id);
+            feature = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
         }
 
         return feature;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java
index 949724290..04fae0399 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java
@@ -25,16 +25,16 @@ public class BiomeSeasonalForest extends Biome
         {
             if(random.nextInt(2) == 0)
             {
-                return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
+                return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
             }
-            return new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
+            return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
         }
         if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id);
+            return new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
         } else
         {
-            return new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id, 4);
+            return new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id(), 4);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java
index 481087ab9..8d07d2ea1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java
@@ -15,6 +15,6 @@ public class BiomeShrubland extends Biome
 	@Override
 	public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        return new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id, Blocks.LOG_OAK.id);
+        return new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java
index 23841fec0..0ece7c0cc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java
@@ -15,6 +15,6 @@ public class BiomeSwamp extends Biome
 	@Override
 	public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        return new WorldFeatureTreeShapeSwamp(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK_MOSSY.id, 6);
+        return new WorldFeatureTreeShapeSwamp(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK_MOSSY.id(), 6);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java
index 373eae536..be0f34a9a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java
@@ -23,10 +23,10 @@ public class BiomeTaiga extends Biome
     {
         if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
+            return new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
         } else
         {
-            return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
+            return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index de9b6da70..9dc78e3b2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -12,24 +12,24 @@ public class Biomes
     public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("seasonal_forest").setColor(0x64ce15));
     public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("forest").setColor(0x26a615));
     public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id).setFillerBlock(Blocks.DIRT_SCORCHED.id));
+    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
     public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("shrubland").setColor(0xbaba38));
     public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id).setFillerBlock(Blocks.SAND.id));
+    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
     public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
-    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id).setFillerBlock(Blocks.BLOCK_SNOW.id));
+    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("meadow").setColor(0x8c8c22));
     public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
     public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("paradise").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
     public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("birch_forest").setColor(0x4bcb5e));
-    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id));
-    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id).setTopBlock(Blocks.DIRT_SCORCHED.id));
+    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id()));
+    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
     public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
-    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id).setFillerBlock(Blocks.DIRT_SCORCHED.id));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id).setFillerBlock(Blocks.MUD_BAKED.id).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id).setFillerBlock(Blocks.MUD_BAKED.id).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
     public static Biome register(String key, Biome biome)
     {
         Registries.BIOMES.register(key, biome);
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 67c5a6bd4..fcf6285b9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
@@ -9,8 +10,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTileEntity;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -495,13 +495,12 @@ public class Chunk
         TileEntity tileEntity = blockEntityMap.get(pos);
         if(tileEntity == null)
         {
-            int id = getBlockID(x, y, z);
-            if(!Blocks.isEntityTile[id])
+            Block<?> block = Blocks.getBlock(getBlockID(x, y, z));
+            if(block == null || !block.isEntityTile)
             {
                 return null;
             }
-            BlockTileEntity tileEntityBlock = (BlockTileEntity)Blocks.blocksList[id];
-            tileEntityBlock.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
+            block.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
             tileEntity = blockEntityMap.get(pos);
         }
         if(tileEntity != null && tileEntity.isInvalid())
@@ -537,7 +536,8 @@ public class Chunk
         tileEntity.x = xPosition * CHUNK_SIZE_X + x;
         tileEntity.y = y;
         tileEntity.z = zPosition * CHUNK_SIZE_Z + z;
-        if (!(Blocks.blocksList[getBlockID(x, y, z)] instanceof BlockTileEntity))
+        Block<?> b = Blocks.blocksList[getBlockID(x, y, z)];
+        if (b == null || !b.isEntityTile)
         {
             LOGGER.warn("Attempted to place a tile entity where there was no entity tile!");
             Thread.dumpStack();
@@ -612,7 +612,7 @@ public class Chunk
         }
     }
 
-    public void getEntitiesWithin(Class<? extends Entity> ofClass, AABB aabb, List<Entity> entities)
+    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities)
     {
         int minSection = Math.max(0, MathHelper.floor((aabb.minY - 2D) / 16D));
         int maxSection = Math.min(MathHelper.floor((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 57918ce91..472de83b1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -9,6 +9,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.Nullable;
 
 public class ChunkCache
     implements WorldSource
@@ -65,7 +66,7 @@ public class ChunkCache
     }
 
     @Override
-    public Block getBlock(int x, int y, int z) {
+    public @Nullable Block<?> getBlock(int x, int y, int z) {
         return Blocks.getBlock(getBlockId(x, y, z));
     }
 
@@ -227,14 +228,14 @@ public class ChunkCache
             return Material.air;
         } else
         {
-            return Blocks.blocksList[l].blockMaterial;
+            return Blocks.blocksList[l].getMaterial();
         }
     }
 
     @Override
 	public boolean isBlockOpaqueCube(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -247,13 +248,13 @@ public class ChunkCache
     @Override
 	public boolean isBlockNormalCube(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
         } else
         {
-            return block.blockMaterial.blocksMotion() && block.isCubeShaped();
+            return block.getMaterial().blocksMotion() && block.isCubeShaped();
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index dd4557136..b4b0cfb22 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.chunk;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
@@ -10,6 +9,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
 
 import java.nio.ByteBuffer;
 import java.nio.ShortBuffer;
@@ -156,10 +156,11 @@ public class ChunkSection {
         }
     }
 
-    public void getEntitiesWithin(Class<? extends Entity> ofClass, AABB aabb, List<Entity> entities) {
+    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities) {
         for (Entity e : this.entities) {
             if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersects(aabb)) {
-                entities.add(e);
+                //noinspection unchecked
+                entities.add((T) e);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index 1cbad469f..1481d1491 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 import java.util.List;
@@ -152,13 +153,13 @@ public class EmptyChunk extends Chunk
     }
 
     @Override
-	public void getEntitiesWithin(Entity toExclude, AABB aabb, List entities)
+	public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities)
     {
     }
 
     @Override
-	public void getEntitiesWithin(Class ofClass, AABB aabb, List entities)
-    {
+    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities) {
+
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java b/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
index 44cb500f6..1f4710cc7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index ed62446aa..c6aeccc92 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -11,7 +11,6 @@ import org.slf4j.Logger;
 
 import java.util.Collection;
 import java.util.HashMap;
-import java.util.Locale;
 import java.util.Map;
 
 public class SpawnerConfig {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
index 4b08708c8..d79716469 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
@@ -129,7 +128,7 @@ public class CavesLargeFeature extends LargeFeature {
                         if (y < this.minY || y >= this.maxY) {
                             continue;
                         }
-                        if (Block.hasTag(blockId, BlockTags.IS_WATER)) {
+                        if (Blocks.hasTag(blockId, BlockTags.IS_WATER)) {
                             hasHitWater = true;
                         }
                         if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
@@ -161,12 +160,12 @@ public class CavesLargeFeature extends LargeFeature {
                         double yPercentage = ((y + 0.5D) - blockY) / height;
                         if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
                             int blockId = result.getBlock(x, yIndex, z);
-                            if (Block.hasTag(blockId, BlockTags.CAVE_GEN_REPLACES_SURFACE)) {
+                            if (Blocks.hasTag(blockId, BlockTags.CAVE_GEN_REPLACES_SURFACE)) {
                                 replaceTopBlock = true;
                             }
-                            if (Block.hasTag(blockId, BlockTags.CAVES_CUT_THROUGH)) {
+                            if (Blocks.hasTag(blockId, BlockTags.CAVES_CUT_THROUGH)) {
                                 if (y < 10) {
-                                    result.setBlock(x, yIndex, z, Blocks.FLUID_LAVA_STILL.id);
+                                    result.setBlock(x, yIndex, z, Blocks.FLUID_LAVA_STILL.id());
                                 } else {
                                     result.setBlock(x, yIndex, z, 0);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java
index 81e74694c..b06374ddc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
@@ -150,7 +149,7 @@ public class WarrensCavesLargeFeature extends LargeFeature {
                         if (y < this.minY || y >= this.maxY) {
                             continue;
                         }
-                        if (Block.hasTag(blockId, BlockTags.IS_WATER)) {
+                        if (Blocks.hasTag(blockId, BlockTags.IS_WATER)) {
                             hasHitWater = true;
                         }
                         if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
@@ -181,7 +180,7 @@ public class WarrensCavesLargeFeature extends LargeFeature {
                         double yPercentage = ((y + 0.5D) - blockY) / height;
                         if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
                             int blockId = result.getBlock(x, yIndex, z);
-                            if (blockId == Blocks.SOULSCHIST.id) {
+                            if (blockId == Blocks.SOULSCHIST.id()) {
                                 result.setBlock(x, yIndex, z, 0);
                             }
                         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
index c9b0b5e25..88ecdfe46 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
@@ -23,7 +23,7 @@ public class ChunkGeneratorResult {
         int section = y / ChunkSection.SECTION_SIZE_Y;
         int cy = y % ChunkSection.SECTION_SIZE_Y;
 
-        Block newBlock = Blocks.getBlock(id);
+        Block<?> newBlock = Blocks.getBlock(id);
 
         // If the array is null and we're only clearing a block, skip creating it; otherwise, create it
         if (sectionBlocksArray[section] == null) {
@@ -35,7 +35,7 @@ public class ChunkGeneratorResult {
         }
 
         // Increment or decrement numBlocksInSection depending on whether we're setting or clearing a block
-        Block currentBlock = Blocks.getBlock(getBlock(x, y, z));
+        Block<?> currentBlock = Blocks.getBlock(getBlock(x, y, z));
         if (newBlock == null && currentBlock != null) {
             numBlocksInSectionArray[section]--;
         } else if (newBlock != null && currentBlock == null) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 78d293c46..9e640a581 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -127,7 +127,7 @@ public class ChunkGeneratorClassic
 
                     if (y == 0)
                     {
-                        blockID = Blocks.BEDROCK.id;
+                        blockID = Blocks.BEDROCK.id();
                     }
 
                     result.setBlock(x, y, z, blockID);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
index 0f681cd77..2fbafffa9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
@@ -12,7 +12,7 @@ public class ChunkDecoratorEmpty
     {
         if (chunk.xPosition == 0 && chunk.zPosition == 0)
         {
-            chunk.setBlockID(0, 0, 0, Blocks.BEDROCK.id);
+            chunk.setBlockID(0, 0, 0, Blocks.BEDROCK.id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
index 96d8888e0..50b6e66cc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
@@ -21,14 +21,14 @@ public class ChunkGeneratorFlat
 
         for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
-                result.setBlock(x, 0, z, Blocks.BEDROCK.id);
+                result.setBlock(x, 0, z, Blocks.BEDROCK.id());
                 for (int y = 1; y < 4; y++) {
-                    result.setBlock(x, y, z, Blocks.STONE.id);
+                    result.setBlock(x, y, z, Blocks.STONE.id());
                 }
                 for (int y = 4; y < 6; y++) {
-                    result.setBlock(x, y, z, Blocks.DIRT.id);
+                    result.setBlock(x, y, z, Blocks.DIRT.id());
                 }
-                result.setBlock(x, 6, z, Blocks.GRASS.id);
+                result.setBlock(x, 6, z, Blocks.GRASS.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
index 83aaa3447..a490a6f92 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
@@ -39,7 +39,7 @@ public class ChunkGeneratorIndev
         // Place bedrock
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                result.setBlock(x, 0, z, Blocks.BEDROCK.id);
+                result.setBlock(x, 0, z, Blocks.BEDROCK.id());
             }
         }
 
